// P-III-4 Výlet
// Worst-case time complexity: O(m^2*log(n))
#include <algorithm>
#include <cassert>
#include <cstdio>
#include <vector>

using namespace std;

struct Edge { int a, b; };

const int MAXN = 10000;

vector<int> neighbors[MAXN];
Edge edges[MAXN * MAXN];

int main() {
  int n, m;
  if (scanf("%d%d", &n, &m) != 2) {
    assert(false);
  }
  assert(1 <= n && n <= MAXN);
  assert(0 <= m && m <= n * (n - 1) / 2);
  for (int i = 0; i < m; i++) {
    int a, b;
    if (scanf("%d%d", &a, &b) != 2) {
      assert(false);
    }
    assert(1 <= a && a < b && b <= n);
    a--;
    b--;
    neighbors[a].push_back(b);
    neighbors[b].push_back(a);
    edges[i] = (Edge) { a, b };
    edges[m + i] = (Edge) { b, a };
  }
  for (int i = 0; i < n; i++) {
    sort(neighbors[i].begin(), neighbors[i].end());
  }
  for (int i = 0; i < m + m; i++) {
    int h1 = edges[i].a, h2 = edges[i].b;
    for (int j = 0; j < m + m; j++) {
      if (i == j) continue;
      int h3 = edges[j].a, h4 = edges[j].b;
      if (h3 == h1 || h3 == h2) continue;
      if (h4 == h1 || h4 == h2) continue;
      auto it1 = lower_bound(neighbors[h1].begin(), neighbors[h1].end(), h4);
      if (it1 == neighbors[h1].end() || *it1 != h4) continue;
      auto it2 = lower_bound(neighbors[h2].begin(), neighbors[h2].end(), h3);
      if (it2 == neighbors[h2].end() || *it2 != h3) continue;
      printf("%d %d %d %d\n", h1 + 1, h2 + 1, h3 + 1, h4 + 1);
      return 0;
    }
  }
  printf("0\n");
  return 0;
}
