// P-III-4 Výlet
// Worst-case time complexity: O(n^2)
#include <cassert>
#include <cstdio>
#include <vector>

using namespace std;

const int MAXN = 10000;

vector<int> neighbors[MAXN];
int common_neighbor[MAXN][MAXN];

int main() {
  int n, m;
  if (scanf("%d%d", &n, &m) != 2) {
    assert(false);
  }
  assert(1 <= n && n <= MAXN);
  assert(0 <= m && m <= n * (n - 1) / 2);
  for (int i = 0; i < m; i++) {
    int a, b;
    if (scanf("%d%d", &a, &b) != 2) {
      assert(false);
    }
    assert(1 <= a && a < b && b <= n);
    a--;
    b--;
    neighbors[a].push_back(b);
    neighbors[b].push_back(a);
  }
  for (int i = 0; i < n; i++) {
    for (int j = 0; j < n; j++) {
      common_neighbor[i][j] = -1;
    }
  }
  for (int h2 = 0; h2 < n; h2++) {
    for (int h1 : neighbors[h2]) {
      for (int h3 : neighbors[h2]) {
        if (h1 == h3) continue;
        if (common_neighbor[h1][h3] != -1) {
          int h4 = common_neighbor[h1][h3];
          printf("%d %d %d %d\n", h1 + 1, h2 + 1, h3 + 1, h4 + 1);
          return 0;
        }
        common_neighbor[h1][h3] = h2;
      }
    }
  }
  printf("0\n");
  return 0;
}
