// P-III-4 Výlet
// Worst-case time complexity: O(n^4*log(n))
#include <algorithm>
#include <cassert>
#include <cstdio>
#include <vector>

using namespace std;

const int MAXN = 10000;

vector<int> neighbors[MAXN];

int main() {
  int n, m;
  if (scanf("%d%d", &n, &m) != 2) {
    assert(false);
  }
  assert(1 <= n && n <= MAXN);
  assert(0 <= m && m <= n * (n - 1) / 2);
  for (int i = 0; i < m; i++) {
    int a, b;
    if (scanf("%d%d", &a, &b) != 2) {
      assert(false);
    }
    assert(1 <= a && a < b && b <= n);
    a--;
    b--;
    neighbors[a].push_back(b);
    neighbors[b].push_back(a);
  }
  for (int i = 0; i < n; i++) {
    sort(neighbors[i].begin(), neighbors[i].end());
  }
  for (int h1 = 0; h1 < n; h1++) {
    for (int h2 : neighbors[h1]) {
      for (int h3 : neighbors[h2]) {
        if (h3 == h1) continue;
        for (int h4 : neighbors[h3]) {
          if (h4 == h1 || h4 == h2) continue;
          auto it = lower_bound(neighbors[h4].begin(), neighbors[h4].end(), h1);
          if (it != neighbors[h4].end() && *it == h1) {
            printf("%d %d %d %d\n", h1 + 1, h2 + 1, h3 + 1, h4 + 1);
            return 0;
          }
        }
      }
    }
  }
  printf("0\n");
  return 0;
}
