// P-III-4 Výlet
// Worst-case time complexity: O(n*m / 64)
#include <bitset>
#include <cassert>
#include <cstdio>
#include <vector>

using namespace std;

struct Edge { int a, b; };

const int MAXN = 10000;

Edge edges[MAXN * MAXN];
bitset<MAXN> neighbors[MAXN];
bitset<MAXN> neighbor_neighbors[MAXN];

int main() {
  int n, m;
  if (scanf("%d%d", &n, &m) != 2) {
    assert(false);
  }
  assert(1 <= n && n <= MAXN);
  assert(0 <= m && m <= n * (n - 1) / 2);
  for (int i = 0; i < m; i++) {
    int a, b;
    if (scanf("%d%d", &a, &b) != 2) {
      assert(false);
    }
    assert(1 <= a && a < b && b <= n);
    a--;
    b--;
    neighbors[a].set(b);
    neighbors[b].set(a);
    edges[i] = (Edge) { a, b };
    edges[m + i] = (Edge) { b, a };
  }
  for (int i = 0; i < m + m; i++) {
    Edge e = edges[i];
    int h1 = e.a, h2 = e.b;
    bitset<MAXN> s = neighbors[h1];
    s.reset(h2);
    if ((neighbor_neighbors[h2] & s).count() >= 1) {
      for (int h4 = 0; h4 < n; h4++) {
        if (h4 == h1 || h4 == h2) continue;
        if (neighbor_neighbors[h2][h4] & s[h4]) {
          bitset<MAXN> s2 = neighbors[h4] & neighbors[h2];
          for (int h3 = 0; h3 < n; h3++) {
            if (h3 == h1 || h3 == h2 || h3 == h4) continue;
            if (s2[h3]) {
              printf("%d %d %d %d\n", h1 + 1, h2 + 1, h3 + 1, h4 + 1);
              return 0;
            }
          }
        }
      }
    }
    neighbor_neighbors[h2] |= s;
  }
  printf("0\n");
  return 0;
}
